/**
 *
 * class for indexing XML generated by lucenebuildproc.pm
 * @author  kjdon@cs.waikato.ac.nz
 * @author  davidb@cs.waikato.ac.nz
 * @version 
 */


import java.io.*;

public class GS2LuceneIndexer {

    public static void main (String args[]) throws Exception { 
	if (args.length != 3) {
	    System.out.println("Usage: java GS2LuceneIndexer doc-tag-level building_dir index");
	    return;
	}
 
	String doc_tag_level     = args[0];
	String building_dirname  = args[1];
	String index_dirname     = args[2];

	String import_dirname = building_dirname + File.separator + "text";

	File import_dir   = new File(import_dirname);
	File building_dir = new File(building_dirname);

	if (!import_dir.exists()) {
	    System.out.println("Couldn't find import directory: "+import_dirname);
	    return;
	}

	File idx_dir = new File(building_dir.getPath()+File.separator+index_dirname+File.separator);
	idx_dir.mkdir();
	
	// Set up indexer
	IndexXML indexer = new IndexXML(doc_tag_level,idx_dir);
	indexer.init();	

	// Read from stdin the files to process
	try {
	    InputStreamReader isr = new InputStreamReader(System.in);;
	    BufferedReader brin = new BufferedReader(isr);

	    StringBuffer xml_text = new StringBuffer(1024);
	    String line = null;
	    while ((line = brin.readLine()) != null) {
		xml_text.append(line);
		if (line.startsWith("</Doc>")) {
		    indexer.indexFile(xml_text.toString());
		    xml_text = new StringBuffer(1024);
		}
		//File xml_file = new File(import_dir + File.separator + line);
		//indexer.indexFile(xml_file); // ****
	    }

	    brin.close();
	    isr.close();

	} catch (IOException e) {
	    System.err.println("Error: unable to read from stdin");
	    e.printStackTrace();
	}

	indexer.finish();
    }
}
